
/* =========================================================================== *
|
|  Copyright (c) 1994-2008 by Kobus Barnard (author).
|
|  Personal and educational use of this code is granted, provided that this
|  header is kept intact, and that the authorship is not misrepresented, that
|  its use is acknowledged in publications, and relevant papers are cited.
|
|  For other use contact the author (kobus AT cs DOT arizona DOT edu).
|
|  Please note that the code in this file has not necessarily been adequately
|  tested. Naturally, there is no guarantee of performance, support, or fitness
|  for any particular task. Nonetheless, I am interested in hearing about
|  problems that you encounter.
|
* =========================================================================== */

#ifndef L_DEBUG_INCLUDED
#define L_DEBUG_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#include "l/l_def.h"

#ifdef TEST
#    define TEST_PSO(x) test_pso x
#else
#    define TEST_PSO(x)
#endif

#define TEST_P_STDERR  TEST_PSE

#ifdef TEST
#    define TEST_PSE(x) test_pse x
#else
#    define TEST_PSE(x)
#endif

int  set_debug_options  (const char* option, const char* value);
int  kjb_set_debug_level(int new_level);
int  kjb_get_debug_level(void);
void hex_print          (FILE*, void*, size_t);
void get_status_string  (int status_num, char* buff, size_t buff_size);

#ifdef STANDARD_VAR_ARGS
#ifndef SGI /* SGI pretends it is lint and gives spurious messages. */
    /*PRINTFLIKE1*/
#endif
    void test_pse(const char*, ...);
    void test_pso(const char*, ...);
#else
    void test_pse(void);
    void test_pso(void);
#endif

#ifdef __cplusplus
}
#endif

#endif

